<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Level 1 Exercises</title>
</head>

<body>
    <script>
        console.log('Ex 13');

        function extractPersonBirthYear(personalCode) {
            const initialDigit = parseInt(personalCode.charAt(0));
            const yearDigits = parseInt(personalCode.substr(1, 2));
            // const yearDigits = parseInt(personalCode.substring(1, 3));

            switch (initialDigit) {
                case 1:
                case 2:
                    return 1800 + yearDigits;
                case 3:
                case 4:
                    return 1900 + yearDigits;
                case 5:
                case 6:
                    return 2000 + yearDigits;
                case 7:
                case 8:
                    return 2100 + yearDigits;
                default:
                    return -1;
            }
        }

        console.log(extractPersonBirthYear('51107121760'));

        console.log('Ex 14');

        const extractPersonGender = function (personalCode) {
            return parseInt(personalCode.charAt(0)) % 2 == 0 ? 'F' : 'M';
        }

        console.log(extractPersonGender('51107121760'));

        console.log('Ex 15');

        const isPersonalCodeValid = personalCode => {
            if (!personalCode || personalCode.length != 11) {
                return false;
            }

            const personalCodeParts = personalCode.split('');
            const personalCodeDigits = [];
            for (let part of personalCodeParts) {
                personalCodeDigits.push(parseInt(part));
            }

            const weights1 = [1, 2, 3, 4, 5, 6, 7, 8, 9, 1];
            let checkNumber = calculateCheckNumber(personalCodeDigits, weights1);

            if (checkNumber != 10) {
                return checkNumber === personalCodeDigits[10];
            } else {
                checkNumber = calculateCheckNumber(personalCodeDigits, [3, 4, 5, 6, 7, 8, 9, 1, 2, 3]);
                if (checkNumber != 10) {
                    return checkNumber === personalCodeDigits[10];
                } else {
                    return 0 === personalCodeDigits[10];
                }
            }
        }

        const calculateCheckNumber = (personalCodeDigits, weights) => {
            let sum = 0;
            for (let i = 0; i < 10; i++) {
                sum += weights[i] * personalCodeDigits[i];
            }
            return sum % 11;
        };

        console.log(isPersonalCodeValid('51107121760'));
    </script>
</body>

</html>